;    
.include "2313def.inc"
.def  	tmp = r16 
.def  	OpnEnbl = r17
.equ	door = PD2
.equ  	code = PD3
.equ  	open = PD4
.equ  	lock = PB2
.equ  	alarm = PB1
.equ  	hl = PB0
.equ  	t05mc = 249					;B TCCR0<-2 (Fck/8)
.equ  	t500mc = 7812				;B TCCR1B<-4 (Fck/256)
.equ  	t7c = 27344					;B TCCR1B<-5 (Fck/1024)
.equ  	t5c = 19531					;B TCCR1B<-5 (Fck/1024)
.cseg
.org 0
		rjmp	RESET				;Reset Handler
		nop		;rjmp EXT_INT		;IRQ0 Handler
		nop		;rjmp EXT_INT1		;IRQ1 Handler
		nop		;rjmp TIM_CAPT1		;Timer1 Capture Handler
		rjmp	TIM_COMP1			;Timer1 Compare Handler
		rjmp	TIM_OVF1			;Timer1 Overflow Handler
		rjmp	TIM_OVF0			;Timer0 Overflow Handler
		nop		;rjmp UART_RXC		;UART RX Complete Handler
		nop		;rjmp UART_DRE		;UDR Empty Handler
		nop		;rjmp UART_TXC		;UART TX Complete Handler
		nop		;rjmp ANA_COMP		;Analog Comparator Handler
TIM_COMP1:
		cbi		PORTB,lock			;  
									;  lock (PB2) 
		reti
TIM_OVF1:
		clr		OpnEnbl				; 
		cbi		PORTB,alarm			;  
									;  alarm (PB1) 
		ldi		tmp,high($10000 - t500mc);
									;  , 
									; 500  
		out		TCNT1H,tmp 
		ldi		tmp,low($10000 - t500mc) 
		out		TCNT1L,tmp 
		in		tmp,TIMSK 
		sbrc	tmp,TOIE0 
		rjmp	cTOIE0 
		sbrs	tmp,TOIE0 
		rjmp	sTOIE0 
CTOIE0:
		cbr		tmp,1<<TOIE0		;   0
 		rjmp	go_ret
sTOIE0:
		sbr		tmp,1<<TOIE0			;   0
go_ret:
		out		TIMSK,tmp
		reti 
TIM_OVF0:
		ldi		tmp,$100 - t05mc	;  
									;, 
									; 0.5 
		out		TCNT0,tmp
		sbis	PORTB,alarm
		rjmp	sAlarm
		sbic	PORTB,alarm
		rjmp	cAlarm
sAlarm:
		sbi		PORTB,alarm			;  alarm
		rjmp	next
cAlarm:
		cbi		PORTB,alarm			;  alarm
next: 
		clr		tmp
		reti
RESET: 
		ldi		tmp,(1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0)
		out		TIMSK,tmp			;  
		sei							;  
		ldi		tmp,low(RAMEND)		;  
		out		SPL,tmp
		clr		tmp					; tmp
		out		DDRD,tmp			;  D - 
		out		PORTB,tmp			;  -  
		ser		tmp					; tmp
		out		PORTD,tmp			; D -  
		out		DDRB,tmp			;   - 
		out		PIND,tmp			;   
		ldi		tmp,15				; 
		out		WDTCR,tmp			;:  wdr 
									; 2 
		clt							; -  
;  
;=======================
main: 
		wdr							;  
		sbis	PIND,code			;  ,
									;   code (PD3)
									; 
		rcall	OpenLock			;  OpenLock 
		sbis	PIND,open			;  ,
									;   open (PD4)
									; 
		rcall	OpenLock			;  OpenLock 
		sbis	PIND,door			;  ,
									;   door (PD2)
									;  
		rcall	DoorIsOpen			; 
									;DoorIsOpen
		clt							; -  
		rjmp	main				;  
									;  main: 
;   
;===============================
;  
;==============================
OpenLock:
		sbi		PORTB,lock			;  
									;  lock  
		ldi		tmp,high($10000 - t7c);   
		out		TCNT1H,tmp			;   
		ldi		tmp,low($10000 - t7c); 7  
		out		TCNT1L,tmp
		ldi		tmp,5				;  1 
		out		TCCR1B,tmp			; 
									;   1024
		ldi		tmp,high($10000 - t5c)
		out		OCR1AH,tmp			;   
		ldi		tmp,low($10000 - t5c);  
		out		OCR1AL,tmp			; 5    
		ldi		OpnEnbl,$ff			;  tmp  
more: 
		wdr
		tst		OpnEnbl
		brne	more				;   more:
									;   
		clr		tmp
		out		TCCR1B,tmp			;  T1
		set							;  7 
									; 
		ret							;  
;    
;=============================================
DoorIsOpen:
		brts	NoClose				;     
									; -  
									; NoClose:
		sbi		PORTB,hl			;  
									;  hl (PB0) 
		in		tmp,TIMSK
		cbr		tmp,1<<OCIE1A		;  
		out		TIMSK,tmp			;  
									;  1   
		ldi		tmp,high($10000 - t500mc) 
		out		TCNT1H,tmp			;  
									; 500    1 
		ldi		tmp,low($10000 - t500mc) 
		out		TCNT1L,tmp
		ldi		tmp,4				;  1  
		out		TCCR1B,tmp			;   256
		ldi		tmp,$100 - t05mc	;  
		out		TCNT0,tmp			; 0.5   0
		ldi		tmp,2				;  0  
		out		TCCR0,tmp			;   8
		sbi		PORTB,alarm			;  
									;  alarm   
NonStop:
		wdr
		rjmp	NonStop
NoClose:
		wdr
		sbis	PIND,door			;  ,
									;   door 
									;(PD2)  
		rjmp	NoClose				;   NoClose
		ldi		tmp,$100 - 255
		out		TCNT0,tmp
		clr		tmp
		out		TIFR,tmp
		ldi		tmp,5
		out		TCCR0,tmp
		in		tmp,TIMSK
		sbr		tmp,1<<TOIE0		;   0
		out		TIMSK,tmp
wait: 
		wdr
		tst		tmp
		brne	wait
		ret							;  
